## -*- coding: utf-8 -*-
## Copyright (C) 2007 Ingeniweb - all rights reserved
## No publication or distribution without authorization
"""
$Id: Install.py 29373 2007-08-22 13:47:15Z olarcheveque $
"""
__author__  = ''
__docformat__ = 'restructuredtext'

# Python imports
from StringIO import StringIO
import string

# CMF imports
from Products.CMFCore.utils import getToolByName
from Products.CMFCore.CMFCorePermissions import ManagePortal

# Archetypes
from Products.Archetypes.Extensions.utils import install_subskin

# Product import
from Products.ENSSkinner.config import PROJECTNAME, GLOBALS, DEPS


# Configlet
ensskinner_control_panel_configlet = {
    'id': 'ensskinner_control_panel_configlet',
    'appId': PROJECTNAME,
    'name': 'ENSSkinner preferences',
    'action': 'string:$portal_url/ensskinner_config',
    'category': 'Products',
    'permission': (ManagePortal,),
    'imageUrl': 'ens_icon.gif',
}



# def installDeps(self, out):
#     qi = getToolByName(self, 'portal_quickinstaller')
#     for dep in DEPS:
#         qi.installProduct(dep)
#     print >> out, 'Dependencies Installed'

def setupSkins(self, out):
    install_subskin(self, out, GLOBALS)
    print >> out, 'Skins Installed'

def setupCSS(self, out):
    # Register ensskinnerinternet css
    ctool = getToolByName(self, 'portal_css')
    ctool.registerStylesheet('ensskinnerinternet.css', title='ENSSkinnerinternet')
    print >> out, 'CSS installed'
    
def install(self):
    out = StringIO()

    # bugged, should switch install script to PloneInstallation for doing this...
    # installDeps(self, out)
    
    # Install skin
    setupSkins(self, out)
    
    # Install css
    setupCSS(self, out)

    # Install configlet
    cptool = getToolByName(self, 'portal_controlpanel')
    try:
        cptool.registerConfiglet(**ensskinner_control_panel_configlet )
        out.write('configlet registred.\n')
    except:
        pass
    
    out.write('Installation completed.\n')
    return out.getvalue()


def uninstall(self):
    out = StringIO()

    # uninstall configlet
    cptool = getToolByName(self, 'portal_controlpanel')
    try:
        cptool.unregisterConfiglet(ensskinner_control_panel_configlet['id'])
        out.write('configlet unregistred.\n')
    except:
        pass
    
